#ifndef TRIANGLE_H
#define TRIANGLE_H

#include "../common/scene.h"

//float intersect_triangle(vector3& origin, vector3& projection, PrimitiveBase* obj, vector3& old_intersection);
//vector3 normal_triangle(vector3& q, PrimitiveBase* PrimitiveHit, vector3& n);
//void triangle_set(PrimitiveBase *obj, char *key, char *value);
//void triangle_setd(PrimitiveBase *obj, char *key, float value);
//void triangle_setup(PrimitiveBase *obj);
//PrimitiveBase *triangle_create(int obj_number);
//void triangle_set_vector(PrimitiveBase *obj, char *key,vector3& v);
//void triangle_from_points_v(PrimitiveBase *obj,vector3* vertices);
//void triangle_from_points(PrimitiveBase *obj, vector3& v1, vector3& v2,vector3& v3);

/*
typedef struct 
{
	vector3 vertex[3];
} triangle_data;
*/

//#define use_vertex_normals

class Triangle : public PrimitiveBase
{
public:
	vector3 vertex[3];
#ifdef use_vertex_normals
	vector3 normals[3];
#endif
	
	Triangle() : PrimitiveBase() { }
	Triangle(int i) : PrimitiveBase(i) { this->obj_type = TRIANGLE; }
	
	virtual vector3 normalAtPoint(const vector3 &p);
	virtual bool rayIntersect(const Ray &r, HitPoint &h);
	bool fastIntersect(const Ray &r, HitPoint &h);
	virtual vector3 center();
	virtual void setup();
	virtual void makeNormal();
	void fromPoints(vector3& v1, vector3& v2, vector3& v3);
	void fromPoints(vector3* vertices);
};
#endif
