#ifndef __BUFFER
#define __BUFFER

#include <stdlib.h>

template <class T>
class Buffer
{
public:
	Buffer() { count = 0; }
	
	Buffer(int count)
	{
		this->count = count;
		this->size = count * sizeof(T);
		getStorage(size);
	}
	
	Buffer(int horizontalSize, int verticalSize)
	{
		this->horz = horizontalSize;
		this->vert = verticalSize;
		this->count = horizontalSize * verticalSize;
		this->size = count * sizeof(T);
		getStorage( this->size );
	}
					 
	void copy(Buffer<T> &original)
	{
		//if(this->data)
		//	free(this->data);
		this->size = original.size;
		this->horz = original.horz;
		this->vert = original.vert;
		this->count = original.count;
		
		for(int i=0; i<this->count; i++)
			this->setIndex(i, original.getIndex(i) );
	}
	
	T& getIndex(const int i, const int j)
	{ return data[ i + j*horz ]; }
	
	T& getIndex(const int i)
	{ return data[ i ]; }
	
	T* getIndexPointer(const int i)
	{ return &data[ i ]; }
	
	T* getIndexPointer(const int i, const int j)
	{ return &data[ i + j*horz ]; }
	
	void setIndex(const int i, const int j, const T &t)
	{ data[ i + j*horz ] = t; }
	
	void setIndex(const int i, const T &t)
	{ data[ i ] = t; }
	
	T* getDataPointer()
	{ return this->data; }
	
	void setDataPointer(T *p)
	{ this->data = p; }
	
	void swapData(Buffer<T> &b)
	{
		T *p = this->data;
		this->data = b.getDataPointer();
		b.setDataPointer(p);
	}
	
	void zeroData()
	{
		memset(this->data, 0, size);
	}
	
	void reset()
	{
		for(int i=0; i<this->count; i++)
		{
			data[i].reset();
		}
	}
	
	int getCount()
	{ return this->count; }
	
private:
	int count;
	int size;
	int horz;
	int vert;
	T *data;
	
	void getStorage( int bytes)
	{
		this->data = (T*) malloc(bytes);
	}
};

#endif
