#include "MotionBlurTracer.h"

extern int frameNumber;

void MotionBlurTracer::render(SlimScene *scene)
{
	int i, x, y;
	float colorScale = 1.0f / numSamples;
	
	cameraPrevious = cameraCurrent;
	cameraCurrent = cameraFuture;
	cameraFuture = *main_scene->camera;
	
	clearCanvas();
	
	if(frameNumber != 1)
		return;
	//if(frameNumber == 2) {
		printf("previous %f %f %f\n", cameraPrevious.pos[0], cameraPrevious.pos[1], cameraPrevious.pos[2]);
		printf("current %f %f %f\n", cameraCurrent.pos[0], cameraCurrent.pos[1], cameraCurrent.pos[2]);
		printf("future %f %f %f\n", cameraFuture.pos[0], cameraFuture.pos[1], cameraFuture.pos[2]);
	//}
	
	//return;

#ifdef MULTIFRAME
	for(int t=0; t<numSamples; t++)
	{
		float toAmount;
		float fromAmount;
		float time;
		Camera temporalCamera = *main_scene->camera;
		Camera *cameraFrom;
		
		/*if(t < numSamples/2)
		{
			//printf("%f\n", time);
			toAmount = (float)t / (numSamples/2);
			fromAmount = (1.0f-toAmount);
			cameraFrom = &cameraPrevious;
			temporalCamera.pos = cameraFrom->pos*fromAmount + cameraCurrent.pos*toAmount;
			temporalCamera.horz = cameraFrom->horz*fromAmount + cameraCurrent.horz*toAmount;
			temporalCamera.vert = cameraFrom->vert*fromAmount + cameraCurrent.vert*toAmount;
			temporalCamera.spreadAcrossHorz = cameraFrom->spreadAcrossHorz*fromAmount + cameraCurrent.spreadAcrossHorz*toAmount;
			temporalCamera.spreadDownVert = cameraFrom->spreadDownVert*fromAmount + cameraCurrent.spreadDownVert*toAmount;
			temporalCamera.topLeftCorner = cameraFrom->topLeftCorner*fromAmount + cameraCurrent.topLeftCorner*toAmount;
		}
		else*/
		{
			//printf("%f\n", time);
			toAmount = (float)t/numSamples;
			fromAmount = (1.0f-toAmount);
			cameraFrom = &cameraFuture;
			temporalCamera.pos = cameraFrom->pos*fromAmount + cameraCurrent.pos*toAmount;
			temporalCamera.horz = cameraFrom->horz*fromAmount + cameraCurrent.horz*toAmount;
			temporalCamera.vert = cameraFrom->vert*fromAmount + cameraCurrent.vert*toAmount;
			temporalCamera.spreadAcrossHorz = cameraFrom->spreadAcrossHorz*fromAmount + cameraCurrent.spreadAcrossHorz*toAmount;
			temporalCamera.spreadDownVert = cameraFrom->spreadDownVert*fromAmount + cameraCurrent.spreadDownVert*toAmount;
			temporalCamera.topLeftCorner = cameraFrom->topLeftCorner*fromAmount + cameraCurrent.topLeftCorner*toAmount;
			temporalCamera.topLeftCorner = cameraFrom->topLeftCorner*fromAmount + cameraCurrent.topLeftCorner*toAmount;
		}
		
		#pragma omp parallel for schedule(dynamic)
		for(int j=0; j<main_scene->height; j++)
		{
			for(int i=0; i<main_scene->width; i++)
			{
				accumulateRay(i,j, main_scene, temporalCamera);
			}
			
			//if(j % 10 == 0)
			//	update_frame_output(main_scene);
		}
	}
#endif
#ifndef MULTIFRAME
	#pragma omp parallel for schedule(dynamic)
	for(int y=0; y<main_scene->height; y++)
	{
		float toAmount;
		float fromAmount;
		float time;
		Camera temporalCamera = *main_scene->camera;
		Camera *cameraFrom;
		
		for(int x=0; x<main_scene->width; x++)
		{
			for(int t=0; t<numSamples; t++)
			{
				time = (float)rand()/RAND_MAX;
				//printf("%f -- ", time);
				
				/*if(time < 1.0f)
				{
					//printf("%f\n", time);
					toAmount = time;
					fromAmount = (1.0f-toAmount);
					cameraFrom = &cameraPrevious;
					temporalCamera.pos = cameraFrom->pos*fromAmount + cameraCurrent.pos*toAmount;
					temporalCamera.horz = cameraFrom->horz*fromAmount + cameraCurrent.horz*toAmount;
					temporalCamera.vert = cameraFrom->vert*fromAmount + cameraCurrent.vert*toAmount;
					temporalCamera.spreadAcrossHorz = cameraFrom->spreadAcrossHorz*fromAmount + cameraCurrent.spreadAcrossHorz*toAmount;
					temporalCamera.spreadDownVert = cameraFrom->spreadDownVert*fromAmount + cameraCurrent.spreadDownVert*toAmount;
					temporalCamera.topLeftCorner = cameraFrom->topLeftCorner*fromAmount + cameraCurrent.topLeftCorner*toAmount;
				}
				else*/
				{
					//time = time - 1.0f;
					//printf("%f\n", time);
					toAmount = time;
					fromAmount = (1.0f-toAmount);
					cameraFrom = &cameraFuture;
					temporalCamera.pos = cameraFrom->pos*fromAmount + cameraCurrent.pos*toAmount;
					temporalCamera.horz = cameraFrom->horz*fromAmount + cameraCurrent.horz*toAmount;
					temporalCamera.vert = cameraFrom->vert*fromAmount + cameraCurrent.vert*toAmount;
					temporalCamera.spreadAcrossHorz = cameraFrom->spreadAcrossHorz*fromAmount + cameraCurrent.spreadAcrossHorz*toAmount;
					temporalCamera.spreadDownVert = cameraFrom->spreadDownVert*fromAmount + cameraCurrent.spreadDownVert*toAmount;
					temporalCamera.topLeftCorner = cameraFrom->topLeftCorner*fromAmount + cameraCurrent.topLeftCorner*toAmount;
					temporalCamera.topLeftCorner = cameraFrom->topLeftCorner*fromAmount + cameraCurrent.topLeftCorner*toAmount;
				}

				accumulateRay(x,y, main_scene, temporalCamera);
				//calcRay(x,y, main_scene, temporalCamera);
			}
		}
	}
#endif
	
	for(int i=0; i<main_scene->width*main_scene->height; i++)
		main_scene->colorOutput->getIndex(i) *= colorScale;
}
