#ifndef __AMBIENT_OCCLUSION
#define __AMBIENT_OCCLUSION

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "../Primitives/PrimitiveBase.h"
#include "../common/Vector3.h"

#include "../common/scene.h"
#include "../common/debug.h"
#include "./shaders.h"
#include "./lighting.h"

static int ambOCount = 0;

inline float ambientOcclusion(SlimScene &scene, vector3 &from, vector3 &normal, float maxDistance, int numSamples)
{
	float visibleSamples = 0.0;

	for(int samples=0; samples<numSamples; samples++)
	{
		//perturb the normal
		vector3 direction;
		direction.diffuseScatter(normal);
		//direction.normalize();

		//check distance
		HitPoint h;
		Ray r(from, direction);
		h.distance = maxDistance;
		
		bool hit = scene.hierarchy->rayIntersectAll(r, h);
		//if(hit) return 0.0f;
		//return 1.0f;

		if(!hit)
			visibleSamples += 1.0;
		//visibleSamples += h.distance;
	}

	return visibleSamples / (float)numSamples;
	//return (float) visibleSamples / (numSamples*maxDistance);
}

#endif
